package sample;

import java.io.FileInputStream;
import java.sql.Connection;

import org.dbunit.Assertion;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.ITable;
import org.dbunit.dataset.xml.FlatXmlDataSet;

/**
 * bZ[Wf[^ANZXNX̃eXg
 */
public class DBAccesserTest extends DatabaseTestCaseBase {
	/** f[^x[XANZXNX */
	private DBAccesser accesser = null;
	/**
	 * RXgN^
	 */	
	public DBAccesserTest(String name) {
		super(name);
	}
	/**
	 * eXg̏
	 * eeXgsOɌĂяo܂B
	 */
	protected void setUp() throws Exception {
		super.setUp();
		// f[^x[XANZXNXp
		Connection conn = getConnection().getConnection();
		accesser = new DBAccesser(conn);
	}
	/**
	 * 1̃bZ[Wf[^̎擾eXg
	 */	
	public void testGetMessage() throws Exception {
		
		// f[^̎擾A
		// bZ[WIDw肵ăf[^𐳂擾ł邩H
		Message msg = accesser.getMessage(1001);
		assertEquals(1001, msg.getMessageId());
		assertEquals("^Cg1001", msg.getTitle());
		assertEquals("Agata", msg.getName());
		assertEquals("bZ[W1001", msg.getMessage());
		
		// ݂ȂbZ[WID̏ꍇnullԂ
		msg = accesser.getMessage(0);
		assertNull(msg);
		
	}
	/**
	 * 1̃bZ[Wf[^̑}eXg
	 */	
	public void testInsertMessage() throws Exception {

		// f[^`FbNAf[^2̂͂
		assertEquals(getTableRowCount("message"), 2);
		
		// messagee[u1̃f[^}
		Connection conn = getConnection().getConnection();
		DBAccesser accesser = new DBAccesser(conn);
		Message inMsg = new Message();
		inMsg.setMessageId(1003);
		inMsg.setTitle("^Cg1003");
		inMsg.setName("Hashimoto");
		inMsg.setMessage("bZ[W1003");
		accesser.insertMessage(inMsg);

		// f[^}3̃f[^
		assertEquals(getTableRowCount("message"), 3);
		
		// }f[^̊mF`FbN
		Message msg = accesser.getMessage(1003);
		assertEquals(inMsg.getMessageId(), msg.getMessageId());
		assertEquals(inMsg.getTitle()    , msg.getTitle());
		assertEquals(inMsg.getName()     , msg.getName());
		assertEquals(inMsg.getMessage()  , msg.getMessage());
	}
	/**
	 * 1̃bZ[Wf[^̍폜eXg
	 */	
	public void testDeleteMessage() throws Exception {
	
		// f[^`FbNAf[^2̂͂
		assertEquals(getTableRowCount("message"), 2);
		
		// bZ[W폜
		accesser.deleteMessage(1001);

		// 폜f[^͎擾łȂ͂
		Message msg = accesser.getMessage(1001);
		assertNull(msg);
		
		//ҒlXMLt@CDBr
		IDataSet dataSet = new FlatXmlDataSet(new FileInputStream("delete_expected.xml"));
		ITable expectedTable = dataSet.getTable("message");
		Assertion.assertEquals(expectedTable, getTable("message"));
	}
	
}
